package nl.iobyte.themepark.api.sign.objects;

import nl.iobyte.themepark.ThemePark;
import nl.iobyte.themepark.api.attraction.enums.Status;
import nl.iobyte.themepark.api.attraction.objects.Attraction;
import nl.iobyte.themepark.api.message.Text;
import org.bukkit.Location;
import org.bukkit.block.Sign;

public class StatusSign {

    private final Attraction attraction;
    private final Location location;

    public StatusSign(Attraction attraction, Location location) {
        this.attraction = attraction;
        this.location = location;
    }

    public Attraction getAttraction() {
        return attraction;
    }

    public Location getLocation() {
        return location;
    }

    public void update() {
        Status status = attraction.getStatus();
        boolean b = location.getChunk().isLoaded();
        if(!b)
            location.getChunk().load(true);

        if(!location.getChunk().isLoaded())
            return;

        if(!(location.getBlock().getState() instanceof Sign)) {
            ThemePark.getInstance().getAPI().getSignManager().removeSign(this);
            return;
        }

        Sign sign = (Sign) location.getBlock().getState();
        sign.setLine(1, Text.color(attraction.getName()));
        sign.setLine(2, Text.color(status.getColor()+status.getName()));
        sign.update();

        if(!b)
            location.getChunk().unload();
    }

}